org.eclipse.net4j.util.io

## Class DelegatingInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.eclipse.net4j.util.io.DelegatingInputStream

- All Implemented Interfaces:
    Closeable, AutoCloseable
  Direct Known Subclasses:
    XORInputStream

      public class DelegatingInputStream
      extends InputStream

  A `DelegatingInputStream` contains some other input stream, which it uses as its basic source of data, possibly transforming the data along the way or providing additional functionality. The class `DelegatingInputStream` itself simply overrides all (see note below) methods of `InputStream` with versions that pass all requests to the contained input stream. Subclasses of `DelegatingInputStream` may further override some of these methods and may also provide additional methods and fields.

  Note: The only difference to `FilterInputStream` is that `DelegatingInputStream` does not override `InputStream.read(byte[])` or `InputStream.read(byte[], int, int)` but rather exposes the original implementations of `InputStream` which call `read()` instead of their delegate counterparts.

  Author:
    Eike Stepper

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected InputStream` | `in` The input stream to be filtered.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `DelegatingInputStream(InputStream in)` Creates a `DelegatingInputStream` by assigning the argument `in` to the field `this.in` so as to remember it for later use.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes that can be read from this input stream without blocking.
    `void` | `close()` Closes this input stream and releases any system resources associated with the stream.
    `InputStream` | `getDelegate()`
    `void` | `mark(int readlimit)` Marks the current position in this input stream.
    `boolean` | `markSupported()` Tests if this input stream supports the `mark` and `reset` methods.
    `int` | `read()` Reads the next byte of data from this input stream.
    `void` | `reset()` Repositions this stream to the position at the time the `mark` method was last called on this input stream.
    `long` | `skip(long n)` Skips over and discards `n` bytes of data from the input stream.

    - ### Methods inherited from class java.io.InputStream

      `read, read`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### in

          protected volatile InputStream in

      The input stream to be filtered.

  - ### Constructor Detail

    - #### DelegatingInputStream

          protected DelegatingInputStream(InputStream in)

      Creates a `DelegatingInputStream` by assigning the argument `in` to the field `this.in` so as to remember it for later use.
      Parameters:
        `in` - the underlying input stream, or `null` if this instance is to be created without an underlying stream.

  - ### Method Detail

    - #### getDelegate

          public InputStream getDelegate()

    - #### read

          public int read()
                   throws IOException

      Reads the next byte of data from this input stream. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

      This method simply performs `in.read()` and returns the result.

      Specified by:
        `read` in class `InputStream`
      Returns:
        the next byte of data, or `-1` if the end of the stream is reached.
      Throws:
        `IOException` - if an I/O error occurs.
      See Also:
        `in`

    - #### skip

          public long skip(long n)
                    throws IOException

      Skips over and discards `n` bytes of data from the input stream. The `skip` method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly `0`. The actual number of bytes skipped is returned.

      This method simply performs `in.skip(n)`.

      Overrides:
        `skip` in class `InputStream`
      Parameters:
        `n` - the number of bytes to be skipped.
      Returns:
        the actual number of bytes skipped.
      Throws:
        `IOException` - if an I/O error occurs.

    - #### available

          public int available()
                        throws IOException

      Returns the number of bytes that can be read from this input stream without blocking.

      This method simply performs `in.available()` and returns the result.

      Overrides:
        `available` in class `InputStream`
      Returns:
        the number of bytes that can be read from the input stream without blocking.
      Throws:
        `IOException` - if an I/O error occurs.
      See Also:
        `in`

    - #### close

          public void close()
                     throws IOException

      Closes this input stream and releases any system resources associated with the stream. This method simply performs `in.close()`.
      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `InputStream`
      Throws:
        `IOException` - if an I/O error occurs.
      See Also:
        `in`

    - #### mark

          public void mark(int readlimit)

      Marks the current position in this input stream. A subsequent call to the `reset` method repositions this stream at the last marked position so that subsequent reads re-read the same bytes.

      The `readlimit` argument tells this input stream to allow that many bytes to be read before the mark position gets invalidated.

      This method simply performs `in.mark(readlimit)`.

      Overrides:
        `mark` in class `InputStream`
      Parameters:
        `readlimit` - the maximum limit of bytes that can be read before the mark position becomes invalid.
      See Also:
        `in`, `reset()`

    - #### reset

          public void reset()
                     throws IOException

      Repositions this stream to the position at the time the `mark` method was last called on this input stream.

      This method simply performs `in.reset()`.

      Stream marks are intended to be used in situations where you need to read ahead a little to see what's in the stream. Often this is most easily done by invoking some general parser. If the stream is of the type handled by the parse, it just chugs along happily. If the stream is not of that type, the parser should toss an exception when it fails. If this happens within readlimit bytes, it allows the outer code to reset the stream and try another parser.

      Overrides:
        `reset` in class `InputStream`
      Throws:
        `IOException` - if the stream has not been marked or if the mark has been invalidated.
      See Also:
        `in`, `mark(int)`

    - #### markSupported

          public boolean markSupported()

      Tests if this input stream supports the `mark` and `reset` methods. This method simply performs `in.markSupported()`.
      Overrides:
        `markSupported` in class `InputStream`
      Returns:
        `true` if this stream type supports the `mark` and `reset` method; `false` otherwise.
      See Also:
        `in`, `InputStream.mark(int)`, `InputStream.reset()`

Copyright (c) 2014 Eike Stepper (Berlin, Germany) and others.
All rights reserved. This program and the accompanying materials are made available under the terms of the Eclipse Public License v1.0 which accompanies this distribution, and is available at http://www.eclipse.org/legal/epl-v10.html